function [BW]=adjustfinger(G)
BW=[];
G=uint8(G);

% Identify ridge-like regions and normalise image
blksze = 16; thresh = 0.1;
[normim, mask] = ridgesegment(G, blksze, thresh);

% Determine ridge orientations
[orientim, reliability] = ridgeorient(normim, 1, 5, 5);

% Determine ridge frequency values across the image
blksze = 36; 
[freq, medfreq] = ridgefreq(normim, mask, orientim, blksze, 5, 5, 15);
    
% Actually I find the median frequency value used across the whole
% fingerprint gives a more satisfactory result...    
freq = medfreq.*mask;
    
% Now apply filters to enhance the ridge pattern
BW = ridgefilter(normim, orientim, freq, 0.5, 0.5, 0);